import React, { useEffect, useState } from 'react';
import { useParams } from 'react-router';
import CircularProgress from '@material-ui/core/CircularProgress';
import List from '@material-ui/core/List';
import ListItem from '@material-ui/core/ListItem';
import ListItemText from '@material-ui/core/ListItemText';
import Card from '@material-ui/core/Card';
import CardContent from '@material-ui/core/CardContent';
import { useAuth0 } from '../react-auth0-spa';

const DetailPage = () => {
  const [detail, setDetail] = useState({});
  const [isLoading, setIsLoading] = useState(true);
  const { apiSun } = useAuth0();

  useEffect(() => {
    setIsLoading(true);
    apiSun.get(`rest/sunshine?q={ '_id': '${id}' }`).then(([data]) => {
      setDetail(data);
      setIsLoading(false);
    });
  }, []);
  const { id } = useParams();
  if (isLoading) {
    return (
      <div>
        <CircularProgress />
      </div>
    );
  }
  return (
    <Card>
      <CardContent>
        Detail of {id}:
        {detail ? (
          <List>
            {Object.entries(detail).map(([key, value]) => (
              <ListItem key={key}>
                <ListItemText primary={key} secondary={value} />
              </ListItem>
            ))}
          </List>
        ) : (
          'Error while fetching detail'
        )}
      </CardContent>
    </Card>
  );
};

export default DetailPage;
